#include <sys/alt_stdio.h>
#include <stdio.h>
#include "altera_avalon_pio_regs.h"
#include "system.h"

#define read_io(x)		IORD_ALTERA_AVALON_PIO_DATA(x)
#define write_io(x,y)	IOWR_ALTERA_AVALON_PIO_DATA(x,y)

void hex_segment(int dat,int sel)
{
	int seg_base[6]={HEX0_BASE,HEX1_BASE,HEX2_BASE,HEX3_BASE,HEX4_BASE,HEX5_BASE };
	int hex_pat[16]={
			0xc0,0xf9,0xa4,0xb0,0x99,0x92,0x82,0xf8,	//0-7
			0x80,0x98,0x88,0x83,0xa7,0xa1,0x86,0x8e };	//8-F

	if((sel<0)||(sel>5))
		return;
	if((dat<0)||(dat>15))
		write_io(seg_base[sel],0xff);
	else
		write_io(seg_base[sel],hex_pat[dat]);
}

int main()
{
	int sw,btn;
	int i,base;
	alt_putstr("Nios II embedded CPU.\n");

	while (1)
	{
		//seven segment
		btn=read_io(BUTTON_BASE) & 0x03;	//mask
		switch(btn){
		case 0x01:	//KEY1 pushed
			base=15;
			break;
		case 0x02:	//KEY0 pushed
			base=10;
			break;
		default:
			base=5;
		}
		sw = read_io(SWITCH_BASE);
		write_io(LED_BASE,sw);
		for(i=0;i<6;i++){
			hex_segment(base-i,i);
		}
	}
	return 0;
}
